#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <zombieplague>
#include <hamsandwich>
#include <cstrike>
#include <sqlx>
#include <sqlx2>
#include <sockets>
#include <zp_stats>
#include <time>

#pragma tabsize 0

#define PLUGIN "[ZP] Stats"
#define VERSION "3.0 [SEMAX]"
#define AUTHOR "Alexandr Korol"

#define CFG_FILE "zp_stats.cfg"

#define VIP_FLAG ADMIN_LEVEL_H

#define zps_bank()		get_pcvar_num( cvar_bank_enable )
#define zps_get_bank_type() get_pcvar_num( cvar_bank_type )
#define zps_get_bank_max() get_pcvar_num( cvar_bank_max )
#define zps_show_best()		get_pcvar_num( cvar_best_show )
#define zps_user_stats(%1)   CheckGameTime( %1 )
#define zps_get_db_id(%1)   gUserDBId[%1]
#define zps_get_user_name(%1)   gUserName[%1]
#define zps_get_user_steam(%1)   gUserSteam[%1]
#define zps_get_user_ip(%1)   gUserIP[%1]
#define zps_is_player(%1) (1 <= %1 <= gPlayerMax) 
#define GetC(%1) SQL_FieldNameToNum( Query, %1)

#define TASK_UP_PL			51206
#define TASK_READ			41206
#define TASK_UP_LV			93842
#define TASK_CLOSECONNECT	14534

#define MOTD_STYLE "<style>body{background:#E6E6E6;}th{background:#F5F5F5;color:#A70000;padding:6px;font-size:16px;}td{background:#FFF; padding:5px 6px}table{color:#333;background:#E6E6E6;font-size:14px;font-family:'Times New Roman';border:2px solid #D9D9D9;}#c{text-align:center}#l{float:left}</style>"
#define MONEY_TIER 8000
new money_total[33]

// const db table ame
new const map_table[] = "zps_maps"
new const pl_table[] = "zps_players"
new const serv_table[] = "zps_servers"
new const servpl_table[] = "zps_server_pl"
new const clst_table[] = "zps_class_stats"
new const zpcl_table[] = "zps_classes"
new const level_table[] = "zps_levels"

new const gLogFile[] = "zps_logs.txt"

new gMapName[32]
new gServerString[25]

new gText[5096]

new db_host[33]
new db_user[33]
new db_password[33]
new db_name[33]

new gTeamWin[3][] = { "draw", "z_win", "h_win" }
new gAuthColum[3][] = { "steam_id", "ip", "login_id" }
new gScoreType[7][]={ "first_zombie", "infect", "z_kills", "h_kills", "n_kills", "s_kills", "suicide" }

new gHitsName[8][] = { "HIT_NONE", "HIT_HEAD", "HIT_CHEST", "HIT_STOMACH", "HIT_LEFTARM", "HIT_RIGHTARM", "HIT_LEFTLEG", "HIT_RIGHTLEG" }

new Array:g_exp// = ArrayCreate( 1, 1 )
new Array:g_name// = ArrayCreate( 32, 1 )
new Array:gLevelMoneyLimit;

enum 
{
	ME_DMG,
	ME_HIT,
	ME_INFECT,
	ME_KILLS,
	ME_NUM
}

enum 
{
	KILLER_ID,
	KILLER_HP,
	KILLER_ARMOUR,
	KILLER_NUM
}

new gMe[33][ME_NUM]
new gKillers[33][KILLER_NUM]
new gHits[33][31][9]
new gKills[33][31]
new gWeapon[33]
new gOldWeapon[33]
new gOldAmmo[33]

new gStartTime[33]
new gCountTime[33]
new gUserIP[33][32]
new gUserSteam[33][32]
new gUserName[33][32]
new gUserDBId[33]
new gTotalDamage[33]
new gGameTime[33]
new gUserMoney[33]

// register system
new gUserLoginID[33]
new bAdding[33]
new bUserReg[33]

new gRegName[33][32]
new gRegPassword[33][32]

new gLogName[33][32]
new gLogPassword[33][32]

new gUserLevel[33]
new gUserExp[33]
new gDamage[33]

// cvars
new cvar_min_time_stats
new cvar_uppl_time
new cvar_damage_message
new cvar_damage_message_zm
new cvar_bank_enable
new cvar_bank_max
new cvar_bank_start
new cvar_bank_type
new cvar_bank_money_max
new cvar_file_zombie
new cvar_best_show
new cvar_best_x
new cvar_best_y
new cvar_best_r
new cvar_best_g
new cvar_best_b
new cvar_best_time
new cvar_me_alive
new cvar_me
new cvar_rank
new cvar_stats
new cvar_top
new cvar_hp
new cvar_auto_save_type
new cvar_save_zc
new cvar_host
new cvar_db
new cvar_user
new cvar_password

new cvar_debug

new cvar_lvl_enable
new cvar_lvl_damage
new cvar_lvl_x
new cvar_lvl_y
new cvar_lvl_r
new cvar_lvl_g
new cvar_lvl_b
new cvar_lvl_time
new cvar_lvl_exp_kill_z
new cvar_lvl_exp_kill_h
new cvar_lvl_exp_kill_nem
new cvar_lvl_exp_kill_suv
new cvar_lvl_exp_suicide
new cvar_lvl_exp_infect

new gMoney

new Handle:SQL_Tuple
new Handle:SQL_Connection 

new MAX_LVL

new gPlayerMax

public plugin_init() 
{
	register_plugin( PLUGIN, VERSION, AUTHOR )

	cvar_min_time_stats = register_cvar( "zp_stats_min_time", "120" )
	cvar_debug = register_cvar( "zp_stats_debug", "1" )
	
	// bank cvars
	cvar_bank_enable = register_cvar( "zp_stats_bank_enable", "1" )
	cvar_bank_money_max = register_cvar( "zp_stats_money_max", "500000" )
	cvar_bank_type = register_cvar( "zp_stats_bank_type", "1" )
	cvar_bank_max = register_cvar( "zp_stats_bank_max", "10000" )
	cvar_bank_start = register_cvar( "zp_stats_bank_start", "4000" )
	
	cvar_host = register_cvar( "zp_stats_host", "" )
	cvar_db = register_cvar( "zp_stats_db", "" )
	cvar_user = register_cvar( "zp_stats_user", "" )
	cvar_password = register_cvar( "zp_stats_password", "" )
	
	cvar_best_show = register_cvar( "zp_stats_show_best", "1" )
	cvar_best_x = register_cvar( "zp_stats_best_x", "0.05" )
	cvar_best_y = register_cvar( "zp_stats_best_y", "0.55" )
	cvar_best_r = register_cvar( "zp_stats_best_r", "100" )
	cvar_best_g = register_cvar( "zp_stats_best_g", "200" )
	cvar_best_b = register_cvar( "zp_stats_best_b", "50" )
	cvar_best_time = register_cvar( "zp_stats_best_time", "6.0" )
	
	cvar_lvl_enable = register_cvar( "zp_stats_lvl_system", "1" )
	cvar_lvl_damage = register_cvar( "zp_stats_lvl_exp_damage", "1000" )
	cvar_lvl_x = register_cvar( "zp_stats_lvl_x", "-1.0" )
	cvar_lvl_y = register_cvar( "zp_stats_lvl_y", "0.98" )
	cvar_lvl_r = register_cvar( "zp_stats_lvl_r", "10" )
	cvar_lvl_g = register_cvar( "zp_stats_lvl_g", "255" )
	cvar_lvl_b = register_cvar( "zp_stats_lvl_b", "10" )
	cvar_lvl_time = register_cvar( "zp_stats_lvl_time", "2.0" )
	
	cvar_lvl_exp_kill_z = register_cvar( "zp_stats_lvl_kill_exp_zombie", "1" )
	cvar_lvl_exp_kill_h = register_cvar( "zp_stats_lvl_kill_exp_human", "2" )
	cvar_lvl_exp_kill_nem = register_cvar( "zp_stats_lvl_kill_exp_nemesis", "5" )
	cvar_lvl_exp_kill_suv = register_cvar( "zp_stats_lvl_kill_exp_survivor", "5" )
	cvar_lvl_exp_suicide = register_cvar( "zp_stats_lvl_dec_exp_suicide", "1" )
	cvar_lvl_exp_infect = register_cvar( "zp_stats_lvl_exp_infect", "1" )
	
	cvar_damage_message = register_cvar( "zp_stats_damage_message", "1" )
	cvar_damage_message_zm = register_cvar( "zp_stats_damage_message_zm", "0" )
	
	cvar_me_alive = register_cvar( "zp_stats_me_alive", "0" )
	cvar_me = register_cvar( "zp_stats_me", "1" )
	cvar_rank = register_cvar( "zp_stats_rank", "1" )
	cvar_top = register_cvar( "zp_stats_top", "1" )
	cvar_hp = register_cvar( "zp_stats_hp", "1" )
	cvar_stats = register_cvar( "zp_stats_stats", "1" )
	
	cvar_uppl_time = register_cvar( "zp_stats_update_players_time", "10.0" )
	cvar_save_zc = register_cvar( "zp_stats_save_zombie_class", "1" )
	cvar_file_zombie = register_cvar( "zp_stats_zombie_class_file", "zp_class.ini" )
	cvar_auto_save_type = register_cvar( "zp_stats_save_type", "3" )
	
	register_cvar( "zp_korol_stats_ver", VERSION, FCVAR_SERVER|FCVAR_SPONLY )
	RegisterHam( Ham_Killed, "player", "fw_HamKilled" )
	RegisterHam( Ham_TakeDamage, "player", "fw_TakeDamage", 1 )
	RegisterHam( Ham_CS_RoundRespawn, "player", "fw_RoundRespawn", 1 )
	RegisterHam( Ham_TraceAttack, "player", "fw_TraceAttack", 1 )
	
	register_message(get_user_msgid("CurWeapon"), "msgCurWeapon")
	
	register_event( "Money", "read_gmsg_Money", "b" )
	register_event( "TextMsg", "restartround", "a", "2&#Game_C","2&#Game_w" ) 
	
	register_clcmd( "say", "handleSay" )
	register_clcmd( "say_team", "handleSay" )
	
	register_concmd("zps_give_money", "zps_give_money_publ", ADMIN_KICK, "- <name> <count>")

	register_dictionary( "zombie_stats.txt" )
	register_dictionary( "time.txt" )
	
	gPlayerMax = get_maxplayers();
	gMoney = get_user_msgid( "Money" )
	
	server_cmd("echo [ZP_STATS] Config Loading")
	new confdir[64], path[128]
	
	get_configsdir( confdir, charsmax(confdir) )
	formatex( path, charsmax(path), "%s/%s", confdir, CFG_FILE )
	server_cmd("exec %s", path)
	server_exec()
	server_cmd("echo [ZP_STATS] Config Loaded")
	
	g_name = ArrayCreate( 32, 1 )
	g_exp = ArrayCreate( 1, 1 )
	gLevelMoneyLimit = ArrayCreate( 1, 1 )
	
	register_clcmd( "say /reg", "cmdRegMenu" );
	register_clcmd( "REGISTER_LOGIN", "RegLogin" );
	register_clcmd( "REGISTER_PASSWORD", "RegPassword" );
	register_clcmd( "AUTH_LOGIN", "AuLogin" );
	register_clcmd( "AUTH_PASSWORD", "AuPassword" );
}

public RegLogin( id )
{
	if( bUserReg[id] )
	{
		zps_print( id, "Вы уже авторизированы!");
		return PLUGIN_HANDLED
	}
	new sName[32];
	read_argv( 1, sName, 31 );

	if( equal(sName[id], "") )
	{
		client_cmd( id, "messagemode REGISTER_LOGIN" );
		return PLUGIN_HANDLED
	}
	CheckConnectMySQL();
	SQL_QuoteString( SQL_Connection, gRegName[id], 31, sName )
	new Handle:Query;
	Query = SQL_PrepareQuery( SQL_Connection, "SELECT * FROM `zps_reg_player` WHERE `login` = '%s';", gRegName[id] );
	RunSQL( Query );
	if( SQL_MoreResults(Query) )
	{
		zps_print( id, "Пользователь с таким Логином уже существует!");
		return PLUGIN_HANDLED
	}
	SQL_FreeHandle( Query );
	
	client_cmd( id, "messagemode REGISTER_PASSWORD" );
	
	return PLUGIN_HANDLED
}

public RegPassword( id )
{
	if( bUserReg[id] )
	{
		zps_print( id, "Вы уже авторизированы!");
		return PLUGIN_HANDLED
	}
	new sPassword[32];
	read_argv( 1, sPassword, 31 )

	if( equal(sPassword, "") )
	{
		client_cmd(id, "messagemode REGISTER_PASSWORD")
		return PLUGIN_HANDLED
	}
	gRegPassword[id] = sPassword;
	CheckConnectMySQL();
	new Handle:Query;
	Query = SQL_PrepareQuery( SQL_Connection, "INSERT INTO `zps_reg_player`(`login`, `password`) VALUES ('%s', '%s');",  gRegName[id],  gRegPassword[id] );
	RunSQL( Query );
	gUserLoginID[id] = SQL_GetInsertId(Query);
	SQL_FreeHandle( Query );
	
	bUserReg[id] = true;
	clearUserInfo( id );
	zps_print( id, "Вы успешно зарегестрировались! Вашы данные для входа:");
	zps_print( id, "Логин: %s | Пароль: %s", gRegName[id],  gRegPassword[id]);
	load( id );
	
	return PLUGIN_HANDLED
}


public AuLogin( id )
{
	if( bUserReg[id] )
	{
		zps_print( id, "Вы уже авторизированы!");
		return PLUGIN_HANDLED
	}
	new sName[32];
	read_argv( 1, sName, 31 );

	if( equal(sName[id], "") )
	{
		client_cmd( id, "messagemode AUTH_LOGIN" );
		return PLUGIN_HANDLED
	}
	CheckConnectMySQL();
	SQL_QuoteString( SQL_Connection, gLogName[id], 31, sName )
	
	client_cmd( id, "messagemode AUTH_PASSWORD" );
	
	return PLUGIN_HANDLED
}

public AuPassword( id )
{
	if( bUserReg[id] )
	{
		zps_print( id, "Вы уже авторизированы!");
		return PLUGIN_HANDLED
	}
	new sPassword[32];
	read_argv( 1, sPassword, 31 )

	if( equal(sPassword, "") )
	{
		client_cmd(id, "messagemode AUTH_PASSWORD")
		return PLUGIN_HANDLED
	}
	gLogPassword[id] = sPassword;
	CheckConnectMySQL();
	new Handle:Query;
	Query = SQL_PrepareQuery( SQL_Connection, "SELECT * FROM `zps_reg_player` WHERE `login` = '%s' AND `password` = '%s';", gLogName[id], gLogPassword[id] );
	RunSQL( Query );
	if( !SQL_MoreResults(Query) )
	{
		zps_print( id, "Пользователь с таким Логином и Паролем не существует!");
		return PLUGIN_HANDLED
	}
	else
	{
			gUserLoginID[id] = SQL_ReadResult( Query, GetC("id") )
	}
	SQL_FreeHandle( Query );
	
	bUserReg[id] = true;
	clearUserInfo( id );
	zps_print( id, "Вы успешно Авторизировались!");
	load( id );
	
	return PLUGIN_HANDLED
}

public cmdRegMenu( id )
{
	new mMenu = menu_create("\rМеню Регистрации", "menu_handler");
	
	if( bUserReg[id] )
	{
		menu_additem( mMenu, "\dРегистрация аккаунта", "1", ADMIN_ADMIN );
		menu_additem( mMenu, "\dВход", "2", ADMIN_ADMIN );
	}
	else
	{
		menu_additem( mMenu, "Регистрация аккаунта", "1", 0 );
		menu_additem( mMenu, "Вход", "2", 0 );
	}
	menu_additem( mMenu, "Информация", "3", 0 );
	menu_additem( mMenu, "Передача аммо", "4", 0 );
	
	menu_display( id, mMenu, 0 );
	
	return PLUGIN_HANDLED
}

public menu_handler(id, menu, item)
{
    if (item == MENU_EXIT)
        return PLUGIN_HANDLED

    new sData[6], sName[64], iAccess, iCallback
    menu_item_getinfo( menu, item, iAccess, sData, charsmax(sData), sName, charsmax(sName), iCallback )

	new iKey = str_to_num( sData );

	switch( iKey )
	{
		case 1:
		{
			client_cmd( id, "messagemode REGISTER_LOGIN" );
			//cmdRegMenu( id );
		}
		case 2:
		{
			client_cmd( id, "messagemode AUTH_LOGIN" )
			//cmdRegMenu( id );
		}
		case 3:
		{
			zps_print( id, "Info Menu Item Selected");
		}
		case 4:
		{
			zps_print( id, "Ammo Transfer Menu Item Selected");
		}
	}
	
	return PLUGIN_HANDLED
}

public plugin_natives() 
{
	register_library( "zp_stats" )
	register_native( "zps_get_user_money", "_get_user_money" )
	register_native( "zps_set_user_money", "_set_user_money" )
	
	register_native( "zps_get_user_level", "_get_user_level" )
	register_native( "zps_set_user_level", "_set_user_level" )
	
	register_native( "zps_get_user_exp", "_get_user_exp" )
	register_native( "zps_set_user_exp", "_set_user_exp" )
}

public _get_user_money( plug, param ) 
{
	if( !(zps_bank() && zps_get_bank_type() == 1) )
		return PLUGIN_HANDLED
		
	if( param != 1 )
		return PLUGIN_HANDLED
	
	new id = get_param(1)
	
	
	if( id < 1 || id > gPlayerMax ) 
		return PLUGIN_HANDLED
	else 
		if( !is_user_connected(id) ) 
			return PLUGIN_HANDLED
	
	if( money_total[id] < MONEY_TIER ) 
		return cs_get_user_money(id)
	else
		return money_total[id]
	
	return PLUGIN_HANDLED
	
}

public _set_user_money( plug, param )
{
	if( !(zps_bank() && zps_get_bank_type() == 1) )
		return PLUGIN_HANDLED
		
	if(param != 2 && param != 3 )
		return PLUGIN_HANDLED
	
	new id = get_param(1)
	
	if( id < 1 || id > gPlayerMax ) 
		return PLUGIN_HANDLED
	else
		if( !is_user_connected(id) )
			return PLUGIN_HANDLED
	
	new ammount = get_param(2)
	
	if( ammount >= MONEY_TIER )
	{
		new change = ammount - money_total[id]
		money_total[id] = ammount
		send_moneymsg(id,change,get_param(3)) 
	}
	else
	{
		if( ammount < 0 ) 
			ammount = 0
			
		cs_set_user_money( id, ammount, get_param(3) )
		money_total[id] = 0
	}
	return PLUGIN_HANDLED	
}

public _set_user_level( id, level )
{
	if( !zps_is_player(id) || !is_user_connected(id) )
		return false
	
	if( level > MAX_LVL )
		level = MAX_LVL

	gUserLevel[id] = level
	return true
}

public _get_user_level( id )
{
	if( !zps_is_player(id) || !is_user_connected(id) )
		return false
	
	return gUserLevel[id]
}

public _set_user_exp( id, exp )
{
	if( !zps_is_player(id) || !is_user_connected(id) )
		return false
	
	gUserExp[id] = exp
	CheckUserLevel( id )
	return true
}

public _get_user_exp( id )
{
	if( !zps_is_player(id) || !is_user_connected(id) )
		return false
	
	return gUserExp[id]
}

public read_gmsg_Money( id ) 
{
	if( !(zps_bank() && zps_get_bank_type() == 1) )
		return PLUGIN_HANDLED
		
	if( !is_user_connected(id) ) 
		return PLUGIN_HANDLED

	new current_total = read_data(1)
	
	if( current_total == 801 )
	{      
		current_total = get_pcvar_num(cvar_bank_start)
		cs_set_user_money( id, current_total,0 )
		money_total[id] = 0
	}
	if( current_total >= MONEY_TIER && !money_total[id] )
	{
		money_total[id] = current_total
		send_moneymsg( id, current_total-MONEY_TIER, read_data(2) )
		
		return PLUGIN_CONTINUE
	}
	if( money_total[id] )
	{
		money_total[id] += current_total - MONEY_TIER
		
		if(money_total[id] < MONEY_TIER)
		{
			cs_set_user_money( id,money_total[id], 1 )
			money_total[id] = 0
		}
		else
		{
			send_moneymsg( id, current_total-MONEY_TIER, read_data(2) )
		}
		
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_CONTINUE
}

public send_moneymsg(id,ammount,flash)
{
	if( !(zps_bank() && zps_get_bank_type() == 1) )
		return
		
	cs_set_user_money( id, MONEY_TIER, 0 ) 
	
	new maxamount = get_pcvar_num(cvar_bank_money_max);
	
	if( money_total[id] >  maxamount )
		money_total[id] =  maxamount
	
	message_begin( MSG_ONE , gMoney , {0,0,0}, id )
	write_long( money_total[id]-ammount )
	write_byte( 0 )
	message_end()

	message_begin( MSG_ONE , gMoney , {0,0,0}, id )
	write_long( money_total[id] )
	write_byte( flash )
	message_end()
}

public zps_give_money_publ( id, level, cid )
{
	if( !cmd_access(id, level, cid, 3) )
		return PLUGIN_HANDLED
	
	if( zps_bank() && zps_get_bank_type() == 1 )
	{
	
		new target[16], ammount[8], players[32]
		
		read_argv( 1,target,15 )
		read_argv( 2,ammount,7 )
		
		players[0] = find_player( "bl", target) 
		
		if(players[0] == 0)
		{
			console_print( id, "Пользователь не найден" )
			return PLUGIN_HANDLED
		}
		else 
			give_money( players, str_to_num(ammount) )
	}
	else
		console_print( id, "Не доступно, возможно банк отключен" )
			
	return PLUGIN_HANDLED
}

public give_money( players[], ammount )
{
	if( !(zps_bank() && zps_get_bank_type() == 1) )
		return
		
	new i
	while( players[i] )
	{
		if( money_total[players[i]] )
		{
			money_total[players[i]] += ammount 
			send_moneymsg( players[i],ammount,1 )
		}
		else if( (cs_get_user_money(players[i]) + ammount) >= MONEY_TIER )
		{
			money_total[players[i]] = cs_get_user_money(players[i]) + ammount
			send_moneymsg( players[i],ammount,1 )
		}
		else
		{
			ammount += cs_get_user_money( players[i] )
			cs_set_user_money( players[i],ammount,1 )
			money_total[players[i]] = 0
		}
		++i
	}
}

public restartround() 
{ 
	if( !(zps_bank() && zps_get_bank_type() == 1) )
		return 
		
	for( new i = 1; i < 33; i++ )
		money_total[i] = 0
} 

public plugin_cfg()
{
	ReadCvars()
	StartPlugin()
}

public ReadCvars()
{
	server_cmd("echo [ZP_STATS] Config Loading")
	new confdir[64], path[128]
	
	get_configsdir( confdir, charsmax(confdir) )
	formatex( path, charsmax(path), "%s/%s", confdir, CFG_FILE )
	server_cmd("exec %s", path)
	server_exec()
	server_cmd("echo [ZP_STATS] Config Loaded")
	
	return PLUGIN_CONTINUE
}

public StartPlugin()
{
	get_pcvar_string( cvar_host, db_host, 32 )
	get_pcvar_string( cvar_db, db_name, 32 )
	get_pcvar_string( cvar_user, db_user, 32 )
	get_pcvar_string( cvar_password, db_password, 32 )

	MySQL_Init_Connect( db_host, db_user, db_password, db_name, true )
	
	load_classes_from_file()
	load_levels_from_file()
	
	if( get_pcvar_float(cvar_uppl_time) > 1 )
		set_task( get_pcvar_float(cvar_uppl_time), "Update_Players_Info", TASK_UP_PL, _, _, "b" )
		
	if( get_pcvar_num(cvar_lvl_enable) )
		set_task( get_pcvar_float(cvar_lvl_time), "ShowHudLevel", TASK_UP_LV, _, _, "b" )
}

public plugin_end()
{
	if( SQL_Connection ) 
		SQL_FreeHandle( SQL_Connection )
		
	if( SQL_Tuple ) 
		SQL_FreeHandle( SQL_Tuple )
}

public MySQL_Init_Connect( host[], user[], pass[], db[], bool:upl )
{
	new sError[256], iError;

	SQL_Tuple = SQL_MakeDbTuple( host, user, pass, db )
	SQL_Connection = SQL_Connect( SQL_Tuple, iError, sError, charsmax(sError) )

	if( SQL_Connection != Empty_Handle )
 	{
   	   	log_to_file( gLogFile, "[ZPS] Успешное подкючение к MySQL" )
		if( upl )
			for( new i = 1; i <= 3; i++ )
				Update_Info( i )
	}
	else
	{
		log_to_file( gLogFile, "[ZPS] Ошибка подключения к MySQL [%d] : %s", iError, sError )
		log_to_file( gLogFile, "[ZPS] Плагин остановлен" )
		pause( "a" )
	}
}

public Update_Info( key )
{
	switch( key )
	{
		case 1:
		{
			get_mapname( gMapName, 31 )
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "INSERT INTO `%s` (`map`) VALUES ('%s') ON DUPLICATE KEY UPDATE `count` = `count` + 1", map_table, gMapName )
		}
		case 2:
		{
			new buffer[25], len
			get_cvar_string( "ip", buffer, 24 )
			len = format( gServerString, 24, buffer )
			
			get_cvar_string( "port", buffer, 24 )
			format( gServerString[len], 24 - len, ":%s", buffer )
		
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "INSERT INTO `%s` (`ip`, `round`) VALUES ('%s', '0') ON DUPLICATE KEY UPDATE `round` = '0'", serv_table, gServerString  )
		}
		case 3:
		{
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "DELETE FROM `%s` WHERE `ip` = '%s' ", servpl_table, gServerString )
		}
	}
}

public Update_Players_Info()
{
	for( new id = 1; id <= gPlayerMax; id++ )
	{
		if( is_user_connected(id) && bAdding[id] && zps_get_db_id(id) )
			UpdatePlayer(id)
	}
}

public UpdatePlayer(id)
{
	new sName[32], Query[256]
	new death = cs_get_user_deaths( id )
	new frags = get_user_frags( id )
	get_user_name( id, sName, 31 )
	SQL_QuoteString( SQL_Connection, gUserName[id], 31, sName )
	new status
	// 0 - default
	// 1 - zombie
	// 2 - first zombie
	// 3 - human
	// 4 - nemesis
	// 5 - survior
	
	if( zp_get_user_zombie(id) )
		status = 1
	else
		status = 3
		
	//if( zp_core_is_first_zombie(id) )
	//	status = 2
		
	if( zp_get_user_survivor(id) )
		status = 4
		
	if( zp_get_user_survivor(id) )
		status = 5

	format( Query, 255, "UPDATE `%s` SET `death` = %d, `kill` = %d, `nick` = '%s', `status` = %d, `alive` = %d WHERE `player_id` = %d", servpl_table, death, frags, zps_get_user_name(id), status, is_user_alive(id) ? 1 : 0, zps_get_db_id(id) )
	SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", Query )
}

public client_connect( id )
{
	clearUserInfo( id );
	bUserReg[id] = false;
	gUserLoginID[id] = 0;
}

public clearUserInfo( id )
{
	if( zps_bank() && zps_get_bank_type() == 1 )
	{
		set_cvar_float("mp_startmoney", 801.0)
		money_total[id] = 0
	}
	gUserDBId[id] = 0
	gTotalDamage[id] = 0
	gGameTime[id] = 0
	gUserLevel[id] = 0
	gUserExp[id] = 0
	gDamage[id] = 0
	gUserMoney[id] = 0
	bAdding[id] = 0
}

public client_putinserver(id)
{
	load( id )
}

public load( id )
{
	new sName[32]
	get_user_name( id, sName, 31 )
	SQL_QuoteString( SQL_Connection, gUserName[id], 31, sName )
	get_user_authid( id, gUserSteam[id], 31 )
	get_user_ip( id, gUserIP[id], 31, 1 )

	gStartTime[id] = get_systime()
	gCountTime[id] = get_systime()
	
	for ( new i = 0; i < 31; i++ )
		arrayset( gHits[id][i], 0, 9 )
		
	if( get_pcvar_num(cvar_debug) )
		log_to_file( gLogFile, "[ZPS] AUTH | Name: %s  STEAM: %s IP: %s Register: %s", sName, gUserSteam[id], gUserIP[id], (bUserReg[id] ? "YES" : "NO") )
		
	if( bUserReg[id] )
	{
		new Query[256], data[1]
		
		data[0] = id
		format( Query, 255, "SELECT * FROM `%s` WHERE `%s`='%d' AND `register`='1'", pl_table, gAuthColum[2], gUserLoginID[id] );
		SQL_ThreadQueryFormat( SQL_Tuple,"ClientConnect_QueryHandler", Query, data, 1 )
	}
	else
	{
		if( equal(gUserSteam[id], "STEAM_0:", 8) )
		{
			new Query[256], data[1]
		
			data[0] = id
			format( Query, 255, "SELECT * FROM `%s` WHERE `%s`='%s' AND `register`='0'", pl_table, gAuthColum[0], gUserSteam[id] );
			SQL_ThreadQueryFormat( SQL_Tuple,"ClientConnect_QueryHandler", Query, data, 1 )
		}
		else
		{
			gUserDBId[id] = 0
			log_to_file( gLogFile, "[ZPS] Ошибка авторизации STEAM_ID: %s.", gUserSteam[id] )
		}
	}
}

public client_disconnect( id )
{
	Save( id, true )
}

public Save( id, bool:disc )
{
	if( !zps_get_db_id(id) )
		return PLUGIN_CONTINUE

	new sName[32]
	get_user_name( id, sName, 31 )
	SQL_QuoteString( SQL_Connection, gUserName[id], 31, sName )
	
	new current_time = get_systime()
	gGameTime[id] = ((current_time - gCountTime[id]))
	gCountTime[id] = current_time;
	new clas = zp_get_user_next_class(id)
	
	if( clas == -1 )
		clas = 0
	
	if( zps_bank() )
	{
		if( zps_get_bank_type() == 1 )
			gUserMoney[id] = zps_get_user_money( id )
		else
			gUserMoney[id] = zp_get_user_ammo_packs( id )
		
		new maxamount;
		
		if( bUserReg[id] )
			maxamount = ArrayGetCell( gLevelMoneyLimit, gUserLevel[id] );
		else
			maxamount = get_pcvar_num( cvar_bank_max );
		
		if( gUserMoney[id] > maxamount )
			gUserMoney[id] = maxamount;
			
	}
	if( disc )
	{
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "DELETE FROM `%s` WHERE `player_id` = %d AND `ip` = '%s'", servpl_table, zps_get_db_id(id), gServerString )
	}
	if( ((get_pcvar_num(cvar_auto_save_type) == 1 || get_pcvar_num(cvar_auto_save_type) == 3) && !disc) || disc )
		if( zps_bank() )
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `money`=%d, `t_money`= `t_money` + %d, `nick`='%s', `t_damage`=`t_damage` + %d, `last_join` = %d, `last_act` = %d, `g_time` = `g_time` + %d, `class` = %d, `level` = %d, `exp` = %d WHERE `id` = %d", pl_table, gUserMoney[id], gUserMoney[id], gUserName[id], gTotalDamage[id], gStartTime[id], current_time, gGameTime[id], clas, gUserLevel[id], gUserExp[id], zps_get_db_id(id) )
		else
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `nick`='%s', `t_damage`=`t_damage` + %d, `last_join` = %d, `last_act` = %d, `g_time` = `g_time` + %d, `class` = %d, `level` = %d, `exp` = %d WHERE `id` = %d", pl_table, gUserName[id], gTotalDamage[id], gStartTime[id], current_time, gGameTime[id], clas, gUserLevel[id], gUserExp[id], zps_get_db_id(id) )
	
	return PLUGIN_CONTINUE
}

public fw_RoundRespawn( id )
{
	ResetMe( id )
}

public ResetMe( id )
{
	arrayset( gKillers[id], 0, KILLER_NUM )
	arrayset( gMe[id], 0, ME_NUM )
}

public fw_TraceAttack( id, idattacker, Float:damage, Float:direction[3], traceresult, damagebits )
{
	if ( id == idattacker || !is_user_alive(idattacker) || !is_user_connected(id) )
		return
		
	if ( zp_get_user_zombie(idattacker) == zp_get_user_zombie(id) )
		return
		
	if ( is_user_alive(idattacker) )
	{
		new hit = get_tr2( traceresult, TR_iHitgroup )
		gHits[idattacker][gWeapon[idattacker]][hit] ++
		gMe[idattacker][ME_HIT] = hit
	}
}

public msgCurWeapon( msgid, dest, id )
{
	if ( get_msg_arg_int(1) )
	{
		static wId, ammo
		wId = get_msg_arg_int(2)
		ammo = get_msg_arg_int(3)
		gWeapon[id] = wId
		switch( wId )
		{
			case CSW_KNIFE:
			{
				gOldWeapon[id] = wId 
				return PLUGIN_CONTINUE
			}
			case CSW_HEGRENADE, CSW_FLASHBANG, CSW_SMOKEGRENADE, CSW_C4: 
				return PLUGIN_CONTINUE
		}
		if ( wId == gOldWeapon[id] && gOldAmmo[id] > ammo )
		{
			if (wId == CSW_XM1014)
				gHits[id][wId][0] += 6
			else if (wId == CSW_M3)
				gHits[id][wId][0] += 9
			else
				gHits[id][wId][0]++
		}
		gOldWeapon[id] = wId
		gOldAmmo[id] = ammo
	}
	return PLUGIN_CONTINUE
}

public fw_TakeDamage( victim, inflictor, attacker, Float:damage, damage_type )
{
	if( !zps_is_player(victim) || !zps_is_player(attacker) )
		return
		
	if ( victim == attacker || !is_user_alive(attacker) || !is_user_connected(victim) )
		return
		
	if ( zp_get_user_zombie(attacker) == zp_get_user_zombie(victim) )
		return
		
	if( is_user_alive(attacker) && is_user_connected(attacker) )
	{
		gMe[attacker][ME_DMG] += floatround(damage)
		gTotalDamage[attacker] += floatround(damage)
		gDamage[attacker] += floatround(damage)
		
		if( get_pcvar_num(cvar_lvl_enable) && gDamage[attacker] >= get_pcvar_num(cvar_lvl_damage) )
		{
			gUserExp[attacker]++
			gDamage[attacker] = 0
			CheckUserLevel(attacker)
		}
	}
		
	new victim_hp = get_user_health( victim )
	
	if( victim_hp < 0 )
		victim_hp = 0
		
	if ( get_pcvar_num(cvar_damage_message) && (get_pcvar_num(cvar_damage_message_zm) || !zp_get_user_zombie(attacker) ) )
		client_print( attacker, print_center, "%L", attacker, "MSG_HP_INFO", victim_hp )		

	// fix for -2147483648 hp bug in hl in many cases
	if ( get_user_health(victim) <= 0 )
		user_kill( victim )
}

public fw_HamKilled(id, attacker, shouldgib)
{
	if( !zps_is_player(id) || !zps_is_player(attacker) )
		return
		
	if( is_user_connected(attacker) )
	{
		gKillers[id][KILLER_ID] = attacker
		gKillers[id][KILLER_HP] = get_user_health( attacker )
		gKillers[id][KILLER_ARMOUR] = get_user_armor( attacker )
		gMe[attacker][ME_KILLS] ++
	}
	
	if( !zps_get_db_id(id) || !zps_get_db_id(attacker) )
		return
	
	
	new type, player = attacker
	
	SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `death` = `death` + 1 WHERE `id` = %d", pl_table, zps_get_db_id(id) )
	
	if( id == attacker || !is_user_connected(attacker) )
	{
		type = 6
		player = id
	}
	else if( zp_get_user_zombie(attacker) )
	{
		if( zp_get_user_survivor(id) )
			type = 5
		else
			type = 3
			
		if ( !zp_get_user_nemesis(attacker) )
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "INSERT INTO `%s` (`id`, `id_player`, `kills`) VALUES (%d, %d, 1) ON DUPLICATE KEY UPDATE `kills` = `kills` + 1", clst_table, zp_get_user_zombie_class(attacker), zps_get_db_id(attacker) )
	}
	else
	{
		if( zp_get_user_nemesis(id) )
			type = 4
		else
		{
			type = 2
			SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "INSERT INTO `%s` (`id`, `id_player`, `death`) VALUES(%d, %d, 1) ON DUPLICATE KEY UPDATE `death` = `death` + 1", clst_table, zp_get_user_zombie_class(id), zps_get_db_id(id) )
		}
	}
	
	if (type == 2 || type == 4)
		gKills[attacker][gWeapon[attacker]]++
		
	if( get_pcvar_num(cvar_lvl_enable) )
	{
		switch( type )
		{
			case 2: gUserExp[attacker] += get_pcvar_num( cvar_lvl_exp_kill_z )
			case 3: gUserExp[attacker] += get_pcvar_num( cvar_lvl_exp_kill_h )
			case 4: gUserExp[attacker] += get_pcvar_num( cvar_lvl_exp_kill_nem )
			case 5: gUserExp[attacker] += get_pcvar_num( cvar_lvl_exp_kill_suv )
			case 6: gUserExp[attacker] -= get_pcvar_num( cvar_lvl_exp_suicide )
		}
		CheckUserLevel(attacker)
	}
		
	SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `%s` = `%s` + 1 WHERE `id`=%d", pl_table, gScoreType[type], gScoreType[type], zps_get_db_id(player) )
}

public CheckUserLevel( id )
{
	if( gUserExp[id] > ArrayGetCell( g_exp, MAX_LVL ) )
		return PLUGIN_HANDLED
	
	if( gUserExp[id]-1 > ArrayGetCell( g_exp, gUserLevel[id] ) )
	{
		if( gUserLevel[id] < MAX_LVL ) 
		{
			gUserLevel[id]++
			zps_print(id, "%L", id, "MSG_LVL_UP", gUserLevel[id], ArrayGetStringHandle(g_name, gUserLevel[id]) ) 
		}
		gUserExp[id] = 0
	}
	return PLUGIN_HANDLED
}

public ShowHudLevel()
{
	static buff[256]
	for( new id = 1; id <= gPlayerMax; id++ )
	{
		if( zps_get_db_id(id) && is_user_alive(id) )
		{
			if( gUserLevel[id] < MAX_LVL )
				format( buff, 255, "%L", id, "HUD_LVL", ArrayGetStringHandle(g_name, gUserLevel[id]), gUserExp[id], ArrayGetCell(g_exp, gUserLevel[id]+1) )
			else
				format( buff, 255, "%L", id, "HUD_LVL_MAX", ArrayGetStringHandle(g_name, gUserLevel[id]) )
				
			set_hudmessage( get_pcvar_num(cvar_lvl_r), get_pcvar_num(cvar_lvl_g), get_pcvar_num(cvar_lvl_b), get_pcvar_float(cvar_lvl_x), get_pcvar_float(cvar_lvl_y), 0, 6.0, get_pcvar_float(cvar_lvl_time) )
			show_hudmessage( id, buff  )
		}
	}
}

public handleSay( id )
{
	new args[64]
	
	read_args( args, charsmax(args) )
	remove_quotes( args )
	
	new arg1[16]
	new arg2[32]
	
	
	strbreak(args, arg1, charsmax(arg1), arg2, charsmax(arg2))
	if( equal(arg1,"/top", 4) )
	{
		if(arg1[4])
			ShowTop( id, str_to_num(arg1[4]) )
		else
			ShowTop( id, 15 )
	}
	else if ( equal(arg1,"/rank") )
		ShowRank(id,arg2)
	else if ( equal(arg1,"/me") )
		ShowMe(id)
	else if ( equal(arg1,"/hp") )
		ShowHp(id)
	else if ( equal(arg1, "/rankstats") || equal(arg1, "/stats") )
		ShowStats(id, arg2)
	
}

public ShowHp(id)
{
	if( !get_pcvar_num( cvar_hp ) )
	{
		zps_print( id, "%L", id, "MSG_CMD_BLOCK" )
		return PLUGIN_HANDLED
	}
	
	if (gKillers[id][KILLER_ID])
	{
		new name[32]
		get_user_name(gKillers[id][KILLER_ID], name, 31)
		client_print(id, print_chat, "%L", id, "MSG_HP",
		name, gKillers[id][KILLER_HP],
		gKillers[id][KILLER_ARMOUR])
	}
	else
		client_print(id, print_chat, "%L", id, "MSG_HP_NO_KILLER")
		
	return PLUGIN_HANDLED
}

public ShowMe( id )
{
	if( !get_pcvar_num( cvar_me ) )
	{
		zps_print( id, "%L", id, "MSG_CMD_BLOCK" )
		return PLUGIN_HANDLED
	}
		
	if( get_pcvar_num( cvar_me_alive ) && !is_user_alive(id) )
	{
		zps_print( id, "%L", id, "MSG_ME_DEATH" )
		return PLUGIN_HANDLED
	}

	
	if( gMe[id][ME_DMG] || gMe[id][ME_KILLS] || gMe[id][ME_INFECT] )
	{
		new hit[32]
		format( hit, 31, "%L", id, gHitsName[gMe[id][ME_HIT]] )
		zps_print( id, "%L", id, "MSG_ME", gMe[id][ME_INFECT], gMe[id][ME_KILLS], gMe[id][ME_DMG], hit )
	}
	else
		zps_print( id, "%L", id, "HIT_NONE" )
		
	return PLUGIN_HANDLED
}

public ShowRank( id, unquoted_whois[] )
{	
	if( !get_pcvar_num( cvar_rank ) )
	{
		zps_print( id, "%L", id, "MSG_CMD_BLOCK" )
		return PLUGIN_HANDLED
	}
	
	if( !zps_get_db_id(id) && !unquoted_whois[0] )
		return PLUGIN_CONTINUE

	CheckConnectMySQL()
	
	new whois[1024]
	
	SQL_QuoteString( SQL_Connection , whois, 1023, unquoted_whois )
	
	new Handle:Query
	new min_time = get_pcvar_num( cvar_min_time_stats )
	new msg_type
	
	Query = SQL_PrepareQuery( SQL_Connection, "SET @_c = 0" )
	RunSQL( Query )
	
	if ( !whois[0] )
	{
		Query = SQL_PrepareQuery( SQL_Connection, "SELECT *,(SELECT COUNT(*) FROM `%s` WHERE `g_time` >= %d) AS `total` FROM  (SELECT *, (@_c := @_c + 1) AS `rank`, ((`infect` + `z_kills` + `h_kills` + `n_kills`*4 + `s_kills`*4+1)/(`suicide`*4+`death`+`infected` + 2)) AS `skill` FROM `%s` WHERE `g_time` >= %d ORDER BY `skill` DESC) AS `newtable` WHERE `id`=%d", pl_table, min_time, pl_table, min_time, zps_get_db_id(id) )
		msg_type = 1
	}
	else
	{
		
		Query = SQL_PrepareQuery( SQL_Connection, "SELECT *,(SELECT COUNT(*) FROM `%s` WHERE `g_time` >= %d) AS `total` FROM  \
		(SELECT *, (@_c := @_c + 1) AS `rank`, ((`infect` + `z_kills` + `h_kills` + `n_kills`*4 + `s_kills`*4) / \
		(`suicide`*4+`death`+`infected` + 1)) AS `skill` FROM `%s` WHERE `g_time` >= %d ORDER BY `skill` DESC) AS \
		`newtable` WHERE `nick` LIKE '%%%s%%' OR `ip` LIKE '%%%s%%' LIMIT 1", pl_table, min_time, pl_table, min_time, whois, whois )

		msg_type = 2
	}
	RunSQL( Query )
	
	if ( SQL_MoreResults(Query) )
	{
		new sName[32]
		SQL_ReadResult( Query, GetC("nick"), sName, 31)
		new infect = SQL_ReadResult( Query, GetC("infect") )
		new z_kill = SQL_ReadResult( Query, GetC("z_kills") )
		new h_kill = SQL_ReadResult( Query, GetC("h_kills") )
		new rank = SQL_ReadResult( Query, GetC("rank") )
		new total = SQL_ReadResult( Query, GetC("total") )
		
		if( msg_type == 1 )
			zps_print( id, "%L", id, "MSG_RANK_ME", rank, total, infect, z_kill, h_kill )
		else
			zps_print( id, "%L", id, "MSG_RANK",  sName, rank, total, infect, z_kill, h_kill )
	} 
	
	else
		zps_print( id, "%L", id, "MSG_NOT_RANKED", whois )
	
	SQL_FreeHandle( Query )
	return PLUGIN_HANDLED
}

public ShowStats(id, unquoted_whois[])
{
	if( !get_pcvar_num( cvar_stats ) )
	{
		zps_print( id, "%L", id, "MSG_CMD_BLOCK" )
		return PLUGIN_HANDLED
	}
	
	if( !zps_get_db_id(id) && !unquoted_whois[0] )
		return PLUGIN_CONTINUE
	
	CheckConnectMySQL()
	
	new zclass, money, infect, z_kills, n_kills, h_kills, online, s_kills, death, infected, damage, rank, total, Float:skill, first_zombie, join, leave, suicide, survivor, nemesis
	
	new whois[1024]
	SQL_QuoteString( SQL_Connection , whois, 1023, unquoted_whois )
	
	new name[100]
	
	new len
	
	new join_str[32], leave_str[32], time_str[64]
	
	new min_time = get_pcvar_num( cvar_min_time_stats )
	
	new Handle:Query = SQL_PrepareQuery( SQL_Connection, "SET @_c = 0" )
	
	RunSQL( Query )
	
	if( !whois[0] )
		Query = SQL_PrepareQuery( SQL_Connection, "SELECT *,(SELECT COUNT(*) FROM `%s` WHERE `g_time` >= %d) AS `total` FROM (SELECT *, (@_c := @_c + 1) AS `rank`, ((`infect` + `z_kills` + `h_kills` + `n_kills`*4 + `s_kills`*4+1)/(`suicide`*4+`death`+`infected` + 2)) AS `skill` FROM `%s` WHERE `g_time` >= %d ORDER BY `skill` DESC) AS `newtable` WHERE `id` = %d LIMIT 1", pl_table, min_time, pl_table, min_time, zps_get_db_id(id) )
	else
		Query = SQL_PrepareQuery( SQL_Connection, "SELECT *,(SELECT COUNT(*) FROM `%s` WHERE `g_time` >= %d) AS `total` FROM (SELECT *, (@_c := @_c + 1) AS `rank`, ((`infect` + `z_kills` + `h_kills` + `n_kills`*4 + `s_kills`*4+1)/(`suicide`*4+`death`+`infected` + 2)) AS `skill` FROM `%s` WHERE `g_time` >= %d ORDER BY `skill` DESC) AS `newtable` WHERE `nick` LIKE '%%%s%%' OR `ip` LIKE '%%%s%%' LIMIT 1", pl_table, min_time, pl_table, min_time, whois, whois )
	
	RunSQL( Query )
	
	if( SQL_MoreResults(Query) )
	{
		zclass = SQL_ReadResult( Query, GetC("class") )
		money = SQL_ReadResult( Query, GetC("money") )
		SQL_ReadResult( Query, GetC("nick"), name, 99)
		damage = SQL_ReadResult( Query, GetC("t_damage"))
		join = SQL_ReadResult( Query, GetC("last_join"))
		leave = SQL_ReadResult( Query, GetC("last_act"))
		first_zombie = SQL_ReadResult( Query, GetC("first_zombie") )
		infect = SQL_ReadResult( Query, GetC("infect"))
		z_kills = SQL_ReadResult( Query, GetC("z_kills"))
		h_kills = SQL_ReadResult( Query, GetC("h_kills"))
		n_kills = SQL_ReadResult( Query, GetC("n_kills"))
		s_kills = SQL_ReadResult( Query, GetC("s_kills"))
		suicide = SQL_ReadResult( Query, GetC("suicide"))
		death = SQL_ReadResult( Query, GetC("death"))
		infected = SQL_ReadResult( Query, GetC("infected"))
		online = SQL_ReadResult( Query, GetC("g_time"))
		survivor = SQL_ReadResult( Query, GetC("survivor"))
		nemesis = SQL_ReadResult( Query, GetC("nemesis"))
		rank = SQL_ReadResult( Query, GetC("rank"))
		SQL_ReadResult( Query, GetC("skill"), skill)		
		total = SQL_ReadResult( Query, GetC("total"))
		
		// Fix Bug nick char
		replace_all( name, 99, " ", "&nbsp;" )
		replace_all( name, 99, "<", " " )
		replace_all( name, 99, ">", " " )
		replace_all( name, 99, "/", " " )
		
		new lH1[32]
		format( lH1, 31, "%L", id, "HTML_H1" )
		new lH2[32]
		format( lH2, 31, "%L", id, "HTML_H2" )
		new lZKills[32]
		format( lZKills, 31, "%L", id, "HTML_ZKILLS" )
		new lHKills[32]
		format( lHKills, 31, "%L", id, "HTML_HKILLS" )
		new lNKills[32]
		format( lNKills, 31, "%L", id, "HTML_NKILLS" )
		new lSKills[32]
		format( lSKills, 31, "%L", id, "HTML_SKILLS" )
		new lInfected[32]
		format( lInfected, 31, "%L", id, "HTML_INFECTED" )
		new lInfect[32]
		format( lInfect, 31, "%L", id, "HTML_INFECT" )
		new lDeath[32]
		format( lDeath, 31, "%L", id, "HTML_DEATH" )
		new lSuicide[32]
		format( lSuicide, 31, "%L", id, "HTML_SUICIDE" )
		new lNGame[32]
		format( lNGame, 31, "%L", id, "HTML_NGAME" )
		new lSGame[32]
		format( lSGame, 31, "%L", id, "HTML_SGAME" )
		new lTGame[32]
		format( lTGame, 31, "%L", id, "HTML_TGAME" )
		new lDamage[32]
		format( lDamage, 31, "%L", id, "HTML_DAMAGE" )
		new lLGame[32]
		format( lLGame, 31, "%L", id, "HTML_LGAME" )
		new lZClasses[32]
		format( lZClasses, 31, "%L", id, "HTML_ZCLASS" )
		new lRank[32]
		format( lRank, 31, "%L", id, "HTML_RANKED" )
		new lPRank[32]
		format( lPRank, 31, "%L", id, "HTML_RANKED_I" )
		new lSkill[32]
		format( lSkill, 31, "%L", id, "HTML_SKILL" )
		new lMoney[32]
		format( lMoney, 31, "%L", id, "HTML_MONEY" )
		new lFZombie[32]
		format( lFZombie, 31, "%L", id, "HTML_FZOMBIE" )
		
		new max_len = charsmax( gText )
		
		len = format( gText, max_len, "<html><head><meta http-equiv=^"Content-Type^" content=^"text/html; charset=utf-8^" />%s</head><body>", MOTD_STYLE )
		
		// table 1 start
		len += format( gText[len], max_len - len, "<table width=45%% id=l><th colspan=2>%s</td>", lH1 )
		
		// table 1 body
		len += format( gText[len], max_len - len, "<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d<tr><td>%s<td>%d", lNGame, nemesis, lSGame, survivor, lZKills, z_kills, lHKills, h_kills, lInfect, infect, lInfected, infected, lNKills, n_kills, lSKills, s_kills, lFZombie, first_zombie, lDeath, death, lSuicide, suicide  )
		
		// table 1 end, table 2 start
		len += format( gText[len], max_len - len, "</table><table width=53%%><th colspan=2>%s</td>", lH2 )
		
		// time srt
		get_time_length( 0, online, timeunit_seconds, time_str, 63 )
		format_time( join_str, 32, "%c", join ) 	
		format_time( leave_str, 32, "%c", leave ) 
		
		new z_clname[32]
		new Handle:QueryZ = SQL_PrepareQuery( SQL_Connection, "SELECT `name` FROM `%s` WHERE `id` = %d LIMIT 1", zpcl_table, zclass )
		RunSQL( QueryZ )
	
		if( SQL_MoreResults(QueryZ) )
			SQL_ReadResult( QueryZ, 0, z_clname, 31)

		SQL_FreeHandle( QueryZ )
	
		new smoney[100]
		format( smoney, 99, "<tr><td>%s<td>%d", lMoney, money )
		
		// table 2 body
		len += format( gText[len], max_len - len, "%s<tr><td>%s<td>%d<tr><td>%s<td>%s<tr><td>%s<td> %s - %s<tr><td>%s<td> %s<tr><td>%s<td> %d %s %d<tr><td>%s<td>%3.4f", (zps_bank() ? smoney : ""), lDamage, damage, lTGame, time_str, lLGame, join_str, leave_str, lZClasses, z_clname, lRank, rank, lPRank, total, lSkill, skill)
		
		// end table 2 and motd
		len += format( gText[len], max_len - len, "</table></body></html>" )
		
		new title[52]
	
		if( !whois[0] )
			format( title, 51, "%L", id, "HTML_TITLE_STATSME" )
		else
			format( title, 51, "%L", id, "HTML_TITLE_STATS", name )
		
		show_motd( id, gText, title )
		
		setc( gText, max_len, 0 )
	} 
	else
		client_print( id, print_chat, "%L", id, "MSG_NOT_RANKED", whois )
	
	SQL_FreeHandle( Query )
	
	return PLUGIN_HANDLED
}

public ShowTop( id, top )
{
	if( !get_pcvar_num( cvar_top ) )
	{
		zps_print( id, "%L", id, "MSG_CMD_BLOCK" )
		return PLUGIN_HANDLED
	}
	
	CheckConnectMySQL()
		
	new count, Handle:Query
	new len
	
	new min_time = get_pcvar_num( cvar_min_time_stats )
	new max_len = charsmax(gText)
	
	new z_kills, h_kills, infected, infect, rank, Name[100]
	Query = SQL_PrepareQuery( SQL_Connection, "SELECT COUNT(*) FROM `%s", pl_table )
	
	RunSQL( Query )

	if( SQL_MoreResults(Query) )
		count = SQL_ReadResult( Query, 0 )
	else
	{
		zps_print( id, "%L", id, "MSG_STATS_NULL")
		return PLUGIN_HANDLED
	}
	new lLooserTop[32]
	format(lLooserTop, 31, "%L", id, "HTML_TITLE_TOP_LOOSERS")
	
	new title[32]
	if (top <= 15)
		format(title, 31, "%L", id, "HTML_TITLE_TOP", top)
	else if (top < count)
		format(title, 31, "%L", id, "HTML_TITLE_TOP_INTERVAL", top - 14, top)
	else
	{
		top = count
		format(title, 31, "%s", lLooserTop)
	}
	
	Query = SQL_PrepareQuery( SQL_Connection, "SET @_c = 0" )
	RunSQL( Query )
	
	Query = SQL_PrepareQuery( SQL_Connection, "SELECT `nick`, `z_kills`, `h_kills`, `infect`, `infected`, `rank` FROM (SELECT *, (@_c := @_c + 1) AS `rank`, ((`infect` + `z_kills` + `h_kills` + `n_kills`*4 + `s_kills`*4+1)/(`suicide`*4+`death`+`infected` + 2)) AS `skill` FROM `%s` WHERE `g_time` >= %d ORDER BY `skill` DESC) AS `newtable` WHERE `rank` <= %d ORDER BY `rank` DESC LIMIT 15", pl_table, min_time, top )
	RunSQL( Query )

	
	while( SQL_MoreResults(Query) )
	{
		SQL_ReadResult( Query, GetC("nick"), Name, 99 )
		z_kills = SQL_ReadResult( Query, GetC("z_kills") )
		h_kills = SQL_ReadResult( Query, GetC("h_kills") )
		infect = SQL_ReadResult( Query, GetC("infect") )
		infected = SQL_ReadResult( Query, GetC("infected") )
		rank = SQL_ReadResult( Query, GetC("rank") )
		
		// Fix Bug nick char
		replace_all( Name, 32, " ", "&nbsp;" )
		replace_all( Name, 32, "<", " " )
		replace_all( Name, 32, ">", " " )
		replace_all( Name, 32, "/", " " )
		
		format(gText, max_len, "<tr><td>%d<td>%s<td>%d<td>%d<td>%d<td>%d</tr>%s",rank, Name, z_kills, h_kills, infect, infected, gText)
		SQL_NextRow( Query )
	}
	
	SQL_FreeHandle( Query )
	
	new lHead[450]
	format(lHead, 449, "%s", MOTD_STYLE )
	new lRank[32]
	format(lRank, 31, "%L", id, "HTML_RANK")
	new lNick[32]
	format(lNick, 31, "%L", id, "HTML_NAME")
	new lInfect[32]
	format(lInfect, 31, "%L", id, "HTML_INFECT")
	new lZKills[32]
	format(lZKills, 31, "%L", id, "HTML_ZKILLS")
	new lHKills[32]
	format(lHKills, 31, "%L", id, "HTML_HKILLS")
	new lInfected[32]
	format(lInfected, 31, "%L", id, "HTML_INFECTED")
	
	len = format(gText, max_len, "<html><head><meta http-equiv=^"Content-Type^" content=^"text/html; charset=utf-8^" />%s</head><body><table width=100%% id=c><tr><th>%s<th>%s<th>%s<th>%s<th>%s<th>%s</tr>%s", lHead, lRank, lNick, lZKills, lHKills, lInfect, lInfected, gText )
	format(gText[len], max_len - len, "</table></body></html>")	
	show_motd( id, gText, title )
	
	setc( gText, max_len, 0 )

	return PLUGIN_HANDLED	
}

public load_levels_from_file()
{	
	new filename[128], atacpath[64], i, len
	get_configsdir( atacpath, 63 )
	formatex( filename, 127, "%s/zps_levels.ini", atacpath )

	if( file_exists(filename) )
	{
		new readdata[64]
		new name[32], exp[16], money_linit[16], value[32]

		for( i = 0; i < 128 && read_file( filename, i, readdata, 63, len ); ++i )
		{
			if (!readdata[0] || readdata[0] == ';') continue;
			
			parse( readdata, name, 31, exp, 15, money_linit, 15 )
		
			SQL_QuoteString( SQL_Connection , value, 1023, name )
			ArrayPushString( g_name, value )
			
			SQL_QuoteString( SQL_Connection , value, 1023, exp )
			ArrayPushCell( g_exp, str_to_num(value) )
			
			SQL_QuoteString( SQL_Connection , value, 1023, money_linit )
			ArrayPushCell( gLevelMoneyLimit, str_to_num(value) )
		}
	}
	
	len = format( gText, charsmax(gText), "INSERT INTO `%s` (`level`, `name`, `exp`, `money_limit`) VALUES", level_table )
	
	new size = ArraySize( g_exp )
	MAX_LVL = size - 1
	for( i = 0; i < size; i++ )
	{
		len += format( gText[len], charsmax(gText) - len, " (%d, '%a', %d, %d),",i, ArrayGetStringHandle(g_name, i),ArrayGetCell(g_exp, i),ArrayGetCell(gLevelMoneyLimit, i) )
	}

	gText[--len] = 0
	SQL_QueryAndIgnore( SQL_Connection, "SET NAMES utf8" )
	SQL_QueryAndIgnore( SQL_Connection, "DELETE FROM `%s`", level_table )
	SQL_QueryAndIgnore( SQL_Connection, gText )
	setc(gText, charsmax(gText), 0)
}

/* Zombie Plague */
public load_classes_from_file()
{
	new Array:g_zclass2_realname = ArrayCreate(32, 1)
	new Array:g_zclass2_name = ArrayCreate(32, 1)
	new Array:g_zclass2_info = ArrayCreate(32, 1)
	new Array:g_zclass2_hp = ArrayCreate(1, 1)
	new Array:g_zclass2_spd = ArrayCreate(1, 1)
	new Array:g_zclass2_grav = ArrayCreate(1, 1)
	new Array:g_zclass2_kb = ArrayCreate(1, 1)
	
	new ZP_ZOMBIECLASSES_FILE[50]
	get_pcvar_string( cvar_file_zombie, ZP_ZOMBIECLASSES_FILE, 49 )
	
	
	new path[64]
	new linedata[2024], key[64], value[960]
	new file
	
	// Build zombie classes file path
	get_configsdir(path, charsmax(path))
	format(path, charsmax(path), "%s/%s", path, ZP_ZOMBIECLASSES_FILE)
	
	// Parse if present
	if (file_exists(path))
	{
		// Open zombie classes file for reading
		file = fopen(path, "rt")
		
		while (file && !feof(file))
		{
			// Read one line at a time
			fgets(file, linedata, charsmax(linedata))
			
			// Replace newlines with a null character to prevent headaches
			replace(linedata, charsmax(linedata), "^n", "")
			
			// Blank line or comment
			if (!linedata[0] || linedata[0] == ';') continue;
			
			// New class starting
			if (linedata[0] == '[')
			{
				// Remove first and last characters (braces)
				linedata[strlen(linedata) - 1] = 0
				copy(linedata, charsmax(linedata), linedata[1])
				
				// Store its real name for future reference
				ArrayPushString(g_zclass2_realname, linedata)
				continue;
			}
			
			// Get key and value(s)
			strtok(linedata, key, charsmax(key), value, charsmax(value), '=')
			
			// Trim spaces
			trim(key)
			trim(value)
			static quoted_value[1024]
			SQL_QuoteString( SQL_Connection , quoted_value, 1023, value)
			
			if (equal(key, "NAME"))
				ArrayPushString(g_zclass2_name, quoted_value)
			else if (equal(key, "INFO"))
				ArrayPushString(g_zclass2_info, quoted_value)
			else if (equal(key, "HEALTH"))
				ArrayPushCell(g_zclass2_hp, str_to_num(quoted_value))
			else if (equal(key, "SPEED"))
				ArrayPushCell(g_zclass2_spd, str_to_num(quoted_value))
			else if (equal(key, "GRAVITY"))
				ArrayPushCell(g_zclass2_grav, str_to_float(quoted_value))
			else if (equal(key, "KNOCKBACK"))
				ArrayPushCell(g_zclass2_kb, str_to_float(quoted_value))
		}
		if (file) fclose(file)
	}
	
	new len
	len = format( gText, charsmax(gText), "INSERT INTO `%s` (`id`, `name`, `info`, `hp`, `speed`, `grav`, `kb`) VALUES", zpcl_table )
	
	new i, size = ArraySize(g_zclass2_realname)
	for (i = 0; i < size; i++)
	{
		len+=format(gText[len], charsmax(gText) - len, " (%d, '%a', '%a', %d, %d, '%2.2f', '%2.2f'),",
		i, ArrayGetStringHandle(g_zclass2_name, i),
		ArrayGetStringHandle(g_zclass2_info, i),
		ArrayGetCell(g_zclass2_hp, i), ArrayGetCell(g_zclass2_spd, i),
		Float:ArrayGetCell(g_zclass2_grav, i),
		Float:ArrayGetCell(g_zclass2_kb, i))
	}
	
	gText[--len] = 0
	SQL_QueryAndIgnore( SQL_Connection, "SET NAMES utf8" )
	SQL_QueryAndIgnore( SQL_Connection, "DELETE FROM `%s`", zpcl_table )
	SQL_QueryAndIgnore( SQL_Connection, gText )
	setc(gText, charsmax(gText), 0)
}

// ZP forwards
public zp_round_ended( win_team )
{
	if( get_playersnum() )
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `%s` = `%s` + 1 WHERE `map` = '%s'", map_table, gTeamWin[win_team], gTeamWin[win_team], gMapName )
	
	new i
	
	if( get_pcvar_num(cvar_auto_save_type) == 2 || get_pcvar_num(cvar_auto_save_type) == 3 )
		for( i = 1; i <= gPlayerMax; i++ )
			if( is_user_connected(i) )
				Save( i, false )
	
	if ( !zps_show_best() )
		return	
	
	new players[32], playersNum, maxInfectId = 0, maxDmgId = 0, maxKillsId = 0
	new message[200], len
	new maxInfectName[32], maxDmgName[32], maxKillsName[32]
	get_players(players, playersNum, "ch")
	
	for ( i = 0; i < playersNum; i++ )
	{
		if ( gMe[players[i]][ME_INFECT] > gMe[players[maxInfectId]][ME_INFECT] )
			maxInfectId = i
		if ( gMe[players[i]][ME_DMG] > gMe[players[maxDmgId]][ME_DMG] )
			maxDmgId = i
		if ( gMe[players[i]][ME_KILLS] > gMe[players[maxKillsId]][ME_KILLS] )
			maxKillsId = i
	}
	
	get_user_name( players[maxInfectId], maxInfectName, 31 )
	get_user_name( players[maxDmgId], maxDmgName, 31)
	get_user_name( players[maxKillsId], maxKillsName, 31 )
	
	if ( !(gMe[players[maxInfectId]][ME_INFECT] || gMe[players[maxKillsId]][ME_KILLS] || gMe[players[maxDmgId]][ME_DMG]) )
		return
	
	for ( i = 0; i < playersNum; i++ )
	{
		len = format( message, charsmax(message), "%L", players[i], "HUD_BEST_TITLE" )
		if ( gMe[players[maxInfectId]][ME_INFECT] )
			len += format( message[len], charsmax(message) - len, "^n%L", players[i], "HUD_BEST_INFECT", maxInfectName, gMe[players[maxInfectId]][ME_INFECT] )
					
		if ( gMe[players[maxKillsId]][ME_KILLS] )
			len += format( message[len], charsmax(message) - len, "^n%L", players[i], "HUD_BEST_KILLS", maxKillsName, gMe[players[maxKillsId]][ME_KILLS] )
					
		if ( gMe[players[maxDmgId]][ME_DMG] )
			len += format(message[len], charsmax(message) - len, "^n%L", players[i], "HUD_BEST_DMG", maxDmgName, gMe[players[maxDmgId]][ME_DMG] )
									
		set_hudmessage( get_pcvar_num(cvar_best_r), get_pcvar_num(cvar_best_g), get_pcvar_num(cvar_best_b), get_pcvar_float(cvar_best_x), get_pcvar_float(cvar_best_y), 0, 0.02, get_pcvar_float(cvar_best_time), 0.0, 1.0 )
		show_hudmessage( players[i], message )
	}
}

public zp_round_started( round_type )
{
	SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `round` = %d", serv_table, round_type  )	
}

public zp_user_humanized_post( id, survivor )
{
	if( survivor )
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `survivor` = `survivor` + 1 WHERE `id`= %d", pl_table, zps_get_db_id( id ) )
}

public zp_user_infected_post( id, infector, nemesis )
{
	if ( infector && id != infector )
	{
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `infected` = `infected` + 1 WHERE `id` = %d", pl_table, zps_get_db_id(id) )
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `infect` = `infect` + 1 WHERE `id` = %d", pl_table, zps_get_db_id(infector) )
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "INSERT INTO `%s` (`id`, `id_player`, `infected`) VALUES(%d, %d, 1) ON DUPLICATE KEY UPDATE `infected` = `infected` + 1", clst_table, zp_get_user_zombie_class(infector), zps_get_db_id(infector) )

		gMe[infector][ME_INFECT]++
		
		if( get_pcvar_num(cvar_lvl_enable) )
		{
			gUserExp[infector] += get_pcvar_num( cvar_lvl_exp_infect )
			CheckUserLevel(infector)
		}
	}
	else if ( !nemesis )
	{
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `first_zombie` = `first_zombie` + 1 WHERE `id`=%d", pl_table, zps_get_db_id(id) )
	}
	else
	{
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "UPDATE `%s` SET `nemesis` = `nemesis` + 1 WHERE `id`=%d", pl_table, zps_get_db_id(id) )
	}
	if (!nemesis)
	{
		SQL_ThreadQueryFormatNoData( SQL_Tuple, "IgnoreHandle", "INSERT INTO `%s` (`id`, `id_player`, `games`) VALUES(%d, %d, 1) ON DUPLICATE KEY UPDATE `games` = `games` + 1", clst_table, zp_get_user_zombie_class(id), zps_get_db_id(id) )
	}
}

// SQL Query
public ClientConnect_QueryHandler( FailState, Handle:Query, Error[], ErrCode, data[], size, Float:querytime )
{
	if( !CheckQuery(FailState, ErrCode, Error) ) 
	{
		SQL_FreeHandle(Query)
		return PLUGIN_HANDLED
	}
	new id
	id = data[0]
	
	if( !is_user_connected(id) )
		return PLUGIN_HANDLED
			
	if( !SQL_NumResults(Query) ) 
	{	
		if( zps_bank() )
			gUserMoney[id] = get_pcvar_num( cvar_bank_start )
			
		new Query[512]
		
		if( bUserReg[id] )
			format(Query, charsmax(Query),"INSERT INTO `%s`(`money`, `t_money`, `nick`, `ip`, `steam_id`, `register`, `login_id`) VALUES ('%d', '%d', '%s', '%s', '%s', '1', '%d')", pl_table, gUserMoney[id], gUserMoney[id], zps_get_user_name(id), zps_get_user_ip(id), zps_get_user_steam(id), gUserLoginID[id] )
		else
			format(Query, charsmax(Query),"INSERT INTO `%s`(`money`, `t_money`, `nick`, `ip`, `steam_id`, `register`) VALUES ('%d', '%d', '%s', '%s', '%s', '0')", pl_table, gUserMoney[id], gUserMoney[id], zps_get_user_name(id), zps_get_user_ip(id), zps_get_user_steam(id) )
		
		new Handle:Qwer = SQL_PrepareQuery( SQL_Connection, Query )
		SQL_Execute( Qwer )
		SQL_FreeHandle( Qwer )
		load( id )
	}
	else 
	{
		if( zps_bank() )
			gUserMoney[id] = SQL_ReadResult( Query, GetC("money") )
		
		gUserDBId[id] = SQL_ReadResult( Query, GetC("id") )
		gUserExp[id] = SQL_ReadResult( Query, GetC("exp") )
		gUserLevel[id] = SQL_ReadResult( Query, GetC("level") )
		
		if( get_pcvar_num(cvar_save_zc ) )
		{
			new clas = SQL_ReadResult( Query, GetC("class") )
			if( clas != -1 )
				zp_set_user_zombie_class( id, clas )
		}
		if( get_pcvar_num(cvar_debug) )
		{
			if( !bUserReg[id] )
				log_to_file( gLogFile, "[ZPS] AUTH OK | STEAM: %s ID: %i LVL: %i MONEY: %i ", gUserSteam[id], gUserDBId[id], gUserExp[id], gUserMoney[id] )
			else
				log_to_file( gLogFile, "[ZPS] AUTH OK | STEAM: %s ID: %i LVL: %i MONEY: %i LOGIN_ID: %d", gUserSteam[id], gUserDBId[id], gUserExp[id], gUserMoney[id], gUserLoginID[id] )
		}
		AddTablePlayersOnline(id)
		if( zps_bank() )
		{
			if( zps_get_bank_type() == 1 )
				zps_set_user_money( id, gUserMoney[id] )
			else
				zp_set_user_ammo_packs( id, gUserMoney[id] )
		}
	}
	return PLUGIN_CONTINUE
}

public AddTablePlayersOnline(id)
{
	if( zps_get_db_id(id) )
	{
		new Handle:Query = SQL_PrepareQuery( SQL_Connection,"SELECT * FROM `%s` WHERE `player_id` = %d", servpl_table, zps_get_db_id(id) )
		RunSQL(Query)
		
		if(!SQL_NumResults(Query))
		{ 
			new sName[32]
			get_user_name( id, sName, 31 )
			SQL_QuoteString( SQL_Connection, gUserName[id], 31, sName )
			RunSQL(SQL_PrepareQuery( SQL_Connection, "INSERT INTO `%s` (`player_id`, `ip`, `nick`) VALUES ('%d', '%s', '%s')", servpl_table, zps_get_db_id(id), gServerString, gUserName[id] ) )
		}
		else
		{
			if( get_pcvar_num(cvar_debug) )
				log_to_file( gLogFile, "[ZPS] Конфликт игроков онлайн." )
		}
		bAdding[id] = 1;
	}
}

public IgnoreHandle( FailState, Handle:Query, Error[], ErrCode, Data[], DataSize )
{
	CheckQuery( FailState, ErrCode, Error )

	SQL_FreeHandle(Query)

	return PLUGIN_HANDLED
}

public CheckConnectMySQL()
{
	new Handle: Query = SQL_PrepareQuery( SQL_Connection, "SELECT * FROM `%s` LIMIT 1", pl_table )
	if( !SQL_Execute(Query) )
	{
		new Error[3096]
		new ErrorNum = SQL_QueryError( Query, Error, charsmax(Error) )
		if( ErrorNum == 2006 )
		{
			MySQL_Init_Connect( db_host, db_user, db_password, db_name, false )
			log_to_file( gLogFile, "[ZPS] Reconnecting MySQL" )
		}
	}
}

public RunSQL( Handle:Query )
{
	CheckConnectMySQL()
	if( !SQL_Execute(Query) )
	{
		new Error[256]
		new ErrorNum = SQL_QueryError( Query, Error, charsmax(Error) )
		log_to_file( gLogFile, "[ZPS] DB Error: %d SQL: %s", ErrorNum, Error )
	}
}

// Stock
stock CheckGameTime( id )
{
	if( !get_pcvar_num(cvar_min_time_stats) )
		return true
	else if( get_pcvar_num(cvar_min_time_stats)*60 < gGameTime[id] )
		return true
	else
		return false
	
	return false
}

stock zps_print(const id, const input[], any:...) 
{ 
    new count = 1
	new players[32] 
    static msg[191]
	
    vformat(msg, 190, input, 3)

    replace_all(msg, 190, "!g", "^4")
    replace_all(msg, 190, "!y", "^1")
    replace_all(msg, 190, "!t", "^3")
	
    if (id) players[0] = id; else get_players(players, count, "ch")
    { 
        for ( new i = 0; i < count; i++ ) 
        { 
            if ( is_user_connected(players[i]) ) 
            { 
                message_begin( MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i] )
                write_byte( players[i] )
                write_string( msg )
                message_end()
            } 
        } 
    } 
}