CREATE TABLE IF NOT EXISTS `zps_classes` (
  `id` int(11) NOT NULL,
  `name` varchar(64) NOT NULL,
  `info` varchar(64) NOT NULL,
  `hp` int(11) NOT NULL,
  `speed` int(11) NOT NULL,
  `grav` decimal(5,2) NOT NULL,
  `kb` decimal(5,2) NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

CREATE TABLE IF NOT EXISTS `zps_class_stats` (
  `id` int(10) unsigned NOT NULL,
  `id_player` int(10) unsigned NOT NULL,
  `infect` int(10) unsigned NOT NULL DEFAULT '0',
  `infected` int(11) NOT NULL DEFAULT '0',
  `kills` int(10) unsigned NOT NULL DEFAULT '0',
  `death` int(10) unsigned NOT NULL DEFAULT '0',
  `games` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`id_player`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `zps_levels` (
  `level` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `exp` int(11) NOT NULL,
  `money_limit` int(11) NOT NULL,
  PRIMARY KEY (`level`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

CREATE TABLE IF NOT EXISTS `zps_maps` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `map` varchar(32) NOT NULL,
  `z_win` int(11) NOT NULL DEFAULT '0',
  `h_win` int(11) NOT NULL DEFAULT '0',
  `draw` int(11) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `map` (`map`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10 ;

CREATE TABLE IF NOT EXISTS `zps_players` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `money` int(11) unsigned NOT NULL DEFAULT '0',
  `t_money` int(11) unsigned NOT NULL DEFAULT '0',
  `nick` varchar(32) NOT NULL,
  `ip` varchar(32) NOT NULL,
  `steam_id` varchar(32) NOT NULL,
  `t_damage` int(11) NOT NULL DEFAULT '0',
  `exp` int(11) NOT NULL DEFAULT '0',
  `level` int(11) NOT NULL DEFAULT '0',
  `last_join` int(11) unsigned NOT NULL DEFAULT '0',
  `last_act` int(11) unsigned NOT NULL DEFAULT '0',
  `first_zombie` int(11) NOT NULL DEFAULT '0',
  `infect` int(11) NOT NULL DEFAULT '0',
  `z_kills` int(11) NOT NULL DEFAULT '0',
  `h_kills` int(11) NOT NULL DEFAULT '0',
  `n_kills` int(11) NOT NULL DEFAULT '0',
  `s_kills` int(11) NOT NULL DEFAULT '0',
  `suicide` int(11) NOT NULL DEFAULT '0',
  `death` int(11) NOT NULL DEFAULT '0',
  `infected` int(11) NOT NULL DEFAULT '0',
  `g_time` int(11) NOT NULL DEFAULT '0',
  `class` int(11) NOT NULL DEFAULT '0',
  `nemesis` int(11) NOT NULL DEFAULT '0',
  `survivor` int(11) NOT NULL DEFAULT '0',
  `weapon_pri` int(11) NOT NULL DEFAULT '-1',
  `weapon_sec` int(11) NOT NULL DEFAULT '-1',
  `register` int(1) NOT NULL,
  `login_id` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ip` (`ip`),
  KEY `steam_id` (`steam_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2110 ;


CREATE TABLE IF NOT EXISTS `zps_reg_player` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(50) NOT NULL,
  `password` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;

CREATE TABLE IF NOT EXISTS `zps_servers` (
  `ip` varchar(32) NOT NULL,
  `round` int(2) NOT NULL,
  PRIMARY KEY (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `zps_server_pl` (
  `player_id` int(11) unsigned NOT NULL,
  `death` int(11) NOT NULL,
  `kill` int(11) NOT NULL,
  `status` int(2) NOT NULL,
  `alive` int(2) NOT NULL,
  `nick` varchar(32) NOT NULL,
  `ip` varchar(128) NOT NULL,
  PRIMARY KEY (`player_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `zps_users` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `password` varchar(255) COLLATE utf8_bin NOT NULL,
  `group` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;
